# MAIN IMPORTS ================================================================================================================================================ #
import psyco
psyco.full()
import es
import popuplib
import playerlib
# ============================================================================================================================================================= #

# * ADMINS LOAD
es.load('sam/admins')

# * SAM IMPORTS
func   = es.import_addon('sam/functions')
admins = es.import_addon('sam/admins')

# * VARIABLES

# ============================================================================================================================================================= #
# ========================================================================== LOAD ============================================================================= #
# ============================================================================================================================================================= #
def load():
	### Load Modules ###
	es.load('sam/base/manager')
	es.load('sam/base/pcontrol')
	es.load('sam/base/addons')

# ============================================================================================================================================================= #
# ========================================================================= UNLOAD ============================================================================ #
# ============================================================================================================================================================= #
def unload():
	### Unloads ###
	es.unload('sam/base/manager')
	es.unload('sam/base/pcontrol')
	es.unload('sam/base/addons')
	es.unload('sam/admins')

	### Popups ###
	func.popupDelete('mainPage')

# ============================================================================================================================================================= #
# ======================================================================= CMD BLOCKS ========================================================================== #
# ============================================================================================================================================================= #
def menuCMD(userid = None):
	if userid == None: userid = es.getcmduserid()
	if admins.checkDB():
		if admins.isAdmin(es.getplayersteamid(userid)): displayMenu(userid)
		else: func.hudhint(userid, func.lang_admins('no_access'), func.admins_hudtag)
	else: admins.firstAdmin(userid)

# ============================================================================================================================================================= #
# ======================================================================= MAIN BLOCKS ========================================================================= #
# ============================================================================================================================================================= #
def displayMenu(userid):
	func.popupDelete('mainPage')
	popup = popuplib.create('mainPage')
	popup.addline('%s | SAM %s' % (func.menutitle, es.ServerVar('sam_version')))
	popup.addline('\n \n :: %s' % func.lang_titles('base_mainPage_title'))
	popup.addline(func.pline)
	popup.addline('->1. %s' % func.lang_titles('pcontrol_name'))
	popup.addline('->2. %s' % func.lang_titles('addons_mapchange_name'))
	popup.addline('->3. %s' % func.lang_titles('addons_name'))
	popup.addline('->4. %s' % func.lang_titles('manager_name'))
	popup.addline(' ')
	popup.addline(func.pline)
	popup.addline('0. %s' % func.lang_word('cancel'))

	if not func.outdated == 0 and not func.outdated == None:
		popup.addline(' \n :: UPDATE SYSTEM\n%s\n' % func.pline)
		popup.addline('%s' % func.lang_base('is_outdated1', {'currentversion':es.ServerVar('sam_version')}))
		popup.addline('%s' % func.lang_base('is_outdated2', {'newversion':func.outdated}))
		popup.addline('->5. Changelog')
		popup.select(5, changelog)

	popup.select(1, pcontrol)
	popup.select(2, mapChanger)
	popup.select(3, addons)
	popup.select(4, manager)
	popup.timeout('view', 20)
	for num in range(6,11): popup.select(num, donothing)
	if int(es.ServerVar('sam_first_admin')) == 0: popup.send(userid)

# ============================================================================================================================================================= #
# ======================================================================== FUNCTIONS ========================================================================== #
# ============================================================================================================================================================= #
def pcontrol(userid, choice, popup):
	block = es.import_addon('sam/base/pcontrol')
	block.modulePopup(userid)

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def mapChanger(userid, choice, popup):
	if es.ServerVar('sam_mapchange') == 1:
		block = es.import_addon('sam/base/addons/mapchange')
		block.modulePopup(userid)
	else:
		func.hudhint(userid, func.lang_addons('addon_is_disabled', {'addon':'Map Change'}))
		displayMenu(userid)

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def addons(userid, choice, popup):
	if admins.checkAccess(es.getplayersteamid(userid), 'Addons Manager'):
		block = es.import_addon('sam/base/addons')
		block.modulePopup(userid)
	else: displayMenu(userid)

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def manager(userid, choice, popup):
	if admins.checkAccess(es.getplayersteamid(userid), 'Admins Manager'):
		block = es.import_addon('sam/base/manager')
		block.modulePopup(userid)
	else: displayMenu(userid)

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def changelog(userid, choice, popup): func.motd(userid, 'http://addons.eventscripts.com/addons/view/sam', 'Version %s Changelog' % func.outdated)

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def donothing(userid, choice, popup): func.popupDelete('mainPage')

# ============================================================================================================================================================= #